Program BST;         { SEARCHING IN A BST + INSERTING }
Uses Crt;

Type ElemType =Integer;
     Ptr = ^Item;
     Item=Record
           Data : ElemType;
           Left,Right : Ptr
          end;

Var Root  : Ptr;          { Tree root pointer }
    x     : ElemType;
    IsIn  : Boolean;
    Place : Ptr;
    Level : Integer;


Procedure Search(Key:ElemType; Var Found: Boolean; Var Node: Ptr);
{ Searches for Key, returns Found, Node (if found) }
Var P,Parent:Ptr;
Begin
  Found:=False; P:=Root;
  Level := 0;
  While (P<>nil) and not Found do begin
    Inc(Level);
    Parent := P;
    If Key=P^.Data then Found:=True     {FOUND}
                   else if Key<P^.Data then P:=P^.Left
                                       else P:=P^.Right;
  end{with};
  Node := Parent;
End;


Procedure Add(Key:ElemType; Var Found: Boolean; Var Node: Ptr);
{ Adds Key, returns Found (not added if true), Node where }
Var P : Ptr;
Begin
  If Root=nil then begin             { Creating root }
         New(P);
         Root := P;
         P^.Data := Key; P^.Left := nil; P^.Right := nil;
         Node := Root;
         Found := False;
       end
  Else begin
   Search(Key,Found,Node);
   If not Found then
      If Key<Node^.Data then begin   { Creating left child }
         New(P);
         Node^.Left := P;
         P^.Data := Key; P^.Left := nil; P^.Right := nil;
        end
      Else begin                     { Creating right child }
         New(P);
         Node^.Right := P;
         P^.Data := Key; P^.Left := nil; P^.Right := nil;
      end;
  end;
End;


Procedure Visit(Node : Ptr);   { VISITING/PROCESSING NODE }
Begin Write(Node^.Data,' ') End;

Procedure Pretrav(Tree : Ptr);  { PREORDER TRAVERSAL }
Begin
  If Tree<>nil then begin
   Visit (Tree);
   Pretrav(Tree^.Left);
   Pretrav(Tree^.Right);
  End{IF};
End;

Procedure Intrav(Tree : Ptr);  { INORDER TRAVERSAL }
Begin
  If Tree<>nil then begin
   Intrav(Tree^.Left);
   Visit (Tree);
   Intrav(Tree^.Right);
  End{IF};
End;

Procedure Posttrav(Tree : Ptr);  { POSTORDER TRAVERSAL }
Begin
  If Tree<>nil then begin
   Posttrav(Tree^.Left);
   Posttrav(Tree^.Right);
   Visit (Tree);
  End{IF};
End;


Begin       {BODY}
  ClrScr;
  Root := nil;       { Empty tree }
  Writeln('Creating a BST (last number = 0):');
  Writeln;
  Repeat
     Write('Enter an integer number: '); Readln(x);
     Add(x,IsIn,Place);
     If IsIn then Writeln('      Key already in, not added');
  Until x=0;
  ClrScr;
  Writeln('Traversals:');
  Writeln;
  Write('Preorder:  ');
  Pretrav(Root);
  Writeln;Writeln;
  Write('Inorder:   ');
  Intrav (Root);
  Writeln;Writeln;
  Write('Postorder: ');
  Posttrav(Root);
  Readln;
  Writeln;Writeln;
  Repeat
    Write ('ENTER NUMBER TO SEARCH FOR, 0 TO STOP: ');
    Readln(x);
    Search(x,IsIn,Place);
    If IsIn Then Writeln('FOUND AT LEVEL ',Level)
            else Writeln('NOT FOUND')
  Until (x=0);
  Readln
END.
