Unit Queue_A;         { Queue by array }

Interface

CONST Length   = 100;
TYPE  ElemType = Char{LongInt};
      QueueP=^Queue;
      Queue=Record
              Size  : 0..Length;            {NUMBER OF ITEMS IN A QUEUE}
              Front : 0..Length-1;          {FIRST IN QUEUE IF NOT EMPTY}
              Rear  : 0..Length-1;          {FIRST FREE AFTER LAST ONE}
              Que   : Array [0..Length-1] of ElemType;
            End;

Procedure Create (Var Q:QueueP);            { CREATING AN EMPTY QUEUE }
Procedure EnQueue(Q:QueueP; X:ElemType);    { ENQUEUEING X TO Q }
Procedure Serve  (Q:QueueP;Var X:ElemType); { REMOVING FIRST ELEMENT }
Function  Empty  (Q:QueueP):Boolean;        { TESTING IF EMPTY }
Function  Full   (Q:QueueP):Boolean;        { TESTING IF FULL }

Implementation

Procedure Create (Var Q:QueueP);            { CREATING AN EMPTY QUEUE }
Begin
  New(Q);
  Q^.Size:=0; Q^.Front:=0; Q^.Rear:=0
End;

Procedure EnQueue(Q:QueueP; X:ElemType);    { ENQUEUEING X TO Q }
Begin
   With Q^ do begin
      Que[Rear]:=X;
      Rear:=(Rear+1) mod Length;  { WRAP AROUND }
      Inc(Size)
   End
End;

Procedure Serve  (Q:QueueP;Var X:ElemType); { REMOVING FIRST ELEMENT }
Begin
  With Q^ do begin
    X:=Que[Front];
    Front:=(Front+1) mod Length;  { WRAP AROUND }
    Dec(Size)
  End
End;

Function  Empty  (Q:QueueP):Boolean;        { TESTING IF EMPTY }
Begin Empty:=(Q^.Size=0) end;

Function  Full   (Q:QueueP):Boolean;        { TESTING IF FULL }
Begin Full := (Q^.Size=Length) end;

End.
