Unit Queue_L;            { Queue by linked list }

Interface

TYPE  ElemType = Char;  { Or anything else if necessary }
      Pointr = ^XItem;
      XItem = record
	        data : Elemtype;
	        next : Pointr;
	      end;
      QueueP = ^Queuetype;
      Queuetype = record
		    head,tail : Pointr;
		    size : Integer;
		  end;

Procedure Create (Var Q:QueueP);            { CREATING AN EMPTY QUEUE }
Procedure EnQueue(Q:QueueP; X:ElemType);    { ENQUEUEING X TO Q }
Procedure Serve  (Q:QueueP;Var X:ElemType); { REMOVING FIRST ELEMENT }
Function  Empty  (Q:QueueP):Boolean;        { TESTING IF EMPTY }
Function  Full   (Q:QueueP):Boolean;        { TESTING IF FULL }

Implementation

Procedure Create (Var Q:QueueP);            { CREATING AN EMPTY QUEUE }
Begin
   New(Q);
   Q^.Size:=0;
   Q^.head:=nil;
   Q^.tail:=nil;
End;

Function  Empty(Q:QueueP):Boolean;         { TESTING IF EMPTY }
Begin Empty:=(Q^.Size=0) end;

Function  Full(Q:QueueP):Boolean;          { TESTING IF FULL }
Begin Full := SizeOf(XItem)>MaxAvail end;

Procedure EnQueue(Q:QueueP; X:ElemType);   { ENQUEUEING X TO Q }
Var p : Pointr;
Begin
 If not Full(Q) then begin
   New(p);
   p^.next := nil;
   p^.data := X;
   If Empty(Q) then Q^.head:=p
	       else Q^.tail^.next:=p;
   Q^.tail:=p;
   Inc(Q^.Size)
 end
End;

Procedure Serve(Q:QueueP; Var X:ElemType); { REMOVING FIRST ELEMENT }
Var p : Pointr;
Begin
  If not Empty(Q) then begin
     p := Q^.head;
     Q^.head := p^.next;
     Dec(Q^.size);
     If Q^.head=nil then Q^.tail:=nil;
     X := p^.data;
     Dispose (p)
  end {if}
End;

End.
